using System;
using System.IO;
using System.Threading;
using System.Runtime.InteropServices;



namespace ChasenForCS
{
	/// <summary>
	/// C#Œ⤂gׂ̃NXłB
	/// </summary>
	public class ChasenCS
	{
		[DllImport("msvcrt.dll")]
		static extern  IntPtr fopen([MarshalAs(UnmanagedType.LPStr)]string file,[MarshalAs(UnmanagedType.LPStr)]string mode); 
		[DllImport("msvcrt.dll")]
		static extern  int fclose(IntPtr stream); 
		[DllImport("libchasen.dll")]
		static extern int chasen_getopt_argv([In,Out]string[] param,IntPtr file);
		//int chasen getopt argv(char **argv, FILE *fp);
		[DllImport("libchasen.dll")]
		static extern int chasen_fparse(IntPtr IN,IntPtr OUT);
		//int chasen fparse(FILE *fp in, *fp out);
		[DllImport("libchasen.dll")]
		static extern int chasen_sparse([MarshalAs(UnmanagedType.LPStr)]string str,IntPtr OUT);
		//int chasen sparse(char *str in, FILE *fp out);
		[DllImport("libchasen.dll")]
		static extern IntPtr chasen_fparse_tostr(IntPtr file);
		//char *chasen fparse tostr(FILE *fp in);
		[DllImport("libchasen.dll")]
		//static extern string chasen_sparse_tostr([MarshalAs(UnmanagedType.LPStr)]string str);
		static extern IntPtr chasen_sparse_tostr([MarshalAs(UnmanagedType.LPStr)]string str);
		//char *chasen sparse tostr(char *str in);
		/// <summary>
		/// ꂽ⤂ɓnĂIvVB
		/// </summary>
		static int optind=0;
		/// <summary>
		/// RXgN^B
		/// </summary>
		public ChasenCS()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}
		/// <summary>
		/// ꂽ⣂ɓnĂIvVB
		/// </summary>
		public static int optionNum
		{
			get
			{
				return optind;
			}
		}
		/// <summary>
		/// ⤂ɃIvVnďB(QȏĂяoۂ͕̓sB)
		/// </summary>
		/// <param name="param">⤂ɓnp[^</param>
		/// <returns>IvV̎w肪true,ԈĂfalse</returns>
		public static bool setParams(string[] param)
		{
			try
			{
				if(param==null)
				{
					throw new NullReferenceException("p[^nullłB");
				}
				string [] temp = new string [param.Length+2];
				temp[0]="chasen";
				temp[temp.Length-1]=null;
				for(int i=1;i<temp.Length-1;i++)
				{
					temp[i]=param[i-1];
				}
				for(int i=1;i<temp.Length-1;i++)
				{
					temp[i]=param[i-1];
				}
				if(chasen_getopt_argv(temp,(IntPtr)null)==0)
				{
					optind=param.Length;
					return true;
				}
				else
				{
					return false;
				}
			}
			catch(StackOverflowException)
			{
				return false;
			}
		}
		/// <summary>
		/// ⤂ɃIvVnďB(QȏĂяoۂ͕̓sB)
		/// </summary>
		/// <param name="param">⤂ɓnp[^B</param>
		/// <param name="filename">ԈIvV̏ꍇ̃G[o͗pt@CB</param>
		/// <returns>IvV̎w肪true,ԈĂfalse</returns>
		public static bool setParams(string[] param,string filename)
		{
			try
			{
				if(param==null)
				{
					throw new NullReferenceException("p[^nullłB");
				}
				if(filename==null)
				{
					throw new ArgumentNullException("t@C̎w̕nullłB");
				}			
				filename=filename.Trim(' ','\t','\0','\b','\n','\r','\f','\a','\v','@');
				if(filename=="")
				{
					throw new ArgumentException("t@C󔒕̂݁A邢͂OoCgłB");
				}
				string [] temp = new string [param.Length+2];
				temp[0]="chasen";
				temp[temp.Length-1]=null;
				for(int i=1;i<temp.Length-1;i++)
				{
					temp[i]=param[i-1];
				}
				IntPtr file = fopen(filename,"w");
				if(chasen_getopt_argv(temp,file)==0)
				{
					optind=param.Length;
					return true;
				}
				else
				{
					return false;
				}
			}			
			catch(StackOverflowException)
			{
				return false;
			}	
			
		}
		/// <summary>
		/// ͂nāA͂̌̕`ԑf́B
		/// </summary>
		/// <param name="str">͂镶́B</param>
		/// <returns>͂ꂽ́B</returns>
		public static string parseStr(string str)
		{
			try
			{
				//return chasen_sparse_tostr(str);
				//IntPtr pt=chasen_sparse_tostr(str);
				//return Marshal.PtrToStringAnsi(pt);
				IntPtr result = chasen_sparse_tostr(str);
				return Marshal.PtrToStringAnsi(result);
			}
			catch(NullReferenceException)
			{
				throw new NullReferenceException("ׂ͂񂪕słB");
			}
		}
		/// <summary>
		/// t@CnāÃt@C͂̌̕`ԑf́B
		/// </summary>
		/// <param name="filename">͂镶͂̃t@CB</param>
		/// <returns>͂ꂽ́B</returns>
		public static string parseFile(string filename)
		{
			if(filename==null)
			{
				throw new ArgumentNullException("t@C̎w̕nullłB");
			}			
			filename=filename.Trim(' ','\t','\0','\b','\n','\r','\f','\a','\v','@');
			if(filename=="")
			{
				throw new ArgumentException("t@C󔒕̂݁A邢͂OoCgłB");
			}
			try
			{
				IntPtr fin=fopen(filename,"r");
				IntPtr pt=chasen_fparse_tostr(fin);
				return Marshal.PtrToStringAnsi(pt);
				fclose(fin);
			}
			catch(NullReferenceException)
			{
				throw new NullReferenceException("t@C݂ȂJ܂łB");
			}
			catch(StackOverflowException)
			{
				return "G[FX^bNI[o[";
			}
				
		}
		/// <summary>
		/// ͂nāAw肳ꂽt@CɌ`ԑf͌ʂóB
		/// </summary>
		/// <param name="str">͂镶́B</param>
		/// <param name="fout">͌ʂi[t@C̃t@CB</param>
		public static void parseStrToFile(string str,string fout)
		{
			if(fout==null)
			{
				throw new ArgumentNullException("t@C̎w̕nullłB");
			}			
			fout=fout.Trim(' ','\t','\0','\b','\n','\r','\f','\a','\v','@');
			if(fout=="")
			{
				throw new ArgumentException("t@C󔒕̂݁A邢͂OoCgłB");
			}
			IntPtr temp=fopen(fout,"w");
			try
			{
				chasen_sparse(str,temp);
			}
			catch(NullReferenceException)
			{
				throw new NullReferenceException("ׂ͂񂪕słB");
			}
			catch(StackOverflowException)
			{
				return;
			}
			fclose(temp);
			return;
		}
		/// <summary>
		/// ͂nāAw肳ꂽt@CɌ`ԑf͌ʂóB
		/// </summary>
		/// <param name="str">͂镶́B</param>
		/// <param name="fout">͌ʂi[t@C̃t@CB</param>
		/// <param name="appendFlg">t@Cɒǉ݃[hŏo͂邩ǂ̃tOB</param>
		public static void parseStrToFile(string str,string fout,bool appendFlg)
		{
			if(fout==null)
			{
				throw new ArgumentNullException("t@C̎w̕nullłB");
			}			
			fout=fout.Trim(' ','\t','\0','\b','\n','\r','\f','\a','\v','@');
			if(fout=="")
			{
				throw new ArgumentException("t@C󔒕̂݁A邢͂OoCgłB");
			}
			IntPtr temp;
			//㏑AǋL̑I
			if(appendFlg)
			{
				temp=fopen(fout,"a");
			}
			else
			{
				temp=fopen(fout,"w");
			}
			try
			{
				chasen_sparse(str,temp);
			}
			catch(NullReferenceException)
			{
				throw new NullReferenceException("ׂ͂񂪕słB");
			}
			catch(StackOverflowException)
			{
				return;
			}
			fclose(temp);
			return;
			
		}
		/// <summary>
		/// wt@C̃t@C͂̕`ԑf͂Aʂwt@C̃t@CɏóB
		/// </summary>
		/// <param name="fin">͂镶̓t@CB</param>
		/// <param name="fout">͌ʂi[t@CB</param>
		public static void parseFileToFile(string fin,string fout)
		{
			if(fout==null)
			{
				throw new ArgumentNullException("o̓t@C̎w̕nullłB");
			}			
			fout=fout.Trim(' ','\t','\0','\b','\n','\r','\f','\a','\v','@');
			if(fout=="")
			{
				throw new ArgumentException("o̓t@C󔒕̂݁A邢͂OoCgłB");
			}

			if(fin==null)
			{
				throw new ArgumentNullException("̓t@C̎w̕nullłB");
			}			
			fin=fin.Trim(' ','\t','\0','\b','\n','\r','\f','\a','\v','@');
			if(fin=="")
			{
				throw new ArgumentException("̓t@C󔒕̂݁A邢͂OoCgłB");
			}

			IntPtr tin,tout;
			try
			{	
				tin =fopen(fin,"r");
				tout=fopen(fout,"w");
				chasen_fparse(tin,tout);
				fclose(tin);
				fclose(tout);
				return;
			}
			catch(NullReferenceException)
			{
				throw new NullReferenceException("t@C݂ȂJ܂łB");
			}
			catch(StackOverflowException)
			{
				return;
			}
		}
		/// <summary>
		/// wt@C̃t@C͂̕`ԑf͂Aʂwt@C̃t@CɏóB
		/// </summary>
		/// <param name="fin">͂镶̓t@CB</param>
		/// <param name="fout">͌ʂi[t@CB</param>
		/// <param name="appendFlg">t@Cɒǉ݃[hŏo͂邩ǂ̃tOB</param>
		public static void parseFileToFile(string fin,string fout,bool appendFlg)
		{
			if(fout==null)
			{
				throw new ArgumentNullException("o̓t@C̎w̕nullłB");
			}			
			fout=fout.Trim(' ','\t','\0','\b','\n','\r','\f','\a','\v','@');
			if(fout=="")
			{
				throw new ArgumentException("o̓t@C󔒕̂݁A邢͂OoCgłB");
			}

			if(fin==null)
			{
				throw new ArgumentNullException("̓t@C̎w̕nullłB");
			}			
			fin=fin.Trim(' ','\t','\0','\b','\n','\r','\f','\a','\v','@');
			if(fin=="")
			{
				throw new ArgumentException("̓t@C󔒕̂݁A邢͂OoCgłB");
			}

			IntPtr tin,tout;
			try
			{	
				tin =fopen(fin,"r");
				//㏑AǋL̑IB
				if(appendFlg)
				{
					tout=fopen(fout,"a");
				}	
				else
				{
					tout=fopen(fout,"w");
				}
				chasen_fparse(tin,tout);
				fclose(tin);
				fclose(tout);
				return;
			}
			catch(NullReferenceException)
			{
				throw new NullReferenceException("t@C݂ȂJ܂łB");
			}
			catch(StackOverflowException)
			{
				return;
			}
		}
	}
}
